<?php

include(file_exists('/usr/local/php/beroConf.php') ? '/usr/local/php/beroConf.php' : '/usr/fallback/beroConf.php');
include('/home/admin/www/include/gui_base.php');

function get_apps_enabled ($root_db) {

	$apps_enabled = $root_db->get("root", "userapp-enabled");

	return((empty($apps_enabled) || $apps_enabled == 0) ? 0 : 1);
}

function get_app_slots ($appname) {

	$ret		= 0;
	$src_dir	= "/apps";

	if (!empty($appname)) {
		$file = $src_dir . "/" . $appname . "/VERSION";

		if ($fh = fopen($file, "r")) {

			$fconts = fread($fh, filesize($file));
			fclose($fh);

			preg_match("/SLOTS=([1-8])/", $fconts, $res);
			$ret = $res[1];
		}
	}

	return($ret);
}

function get_app_desc ($appname) {

	$ret		= 0;
	$src_dir	= "/apps";

	if (!empty($appname)) {
		$file = $src_dir . "/" . $appname . "/VERSION";

		if ($fh = fopen($file, "r")) {

			$fconts = fread($fh, filesize($file));
			fclose($fh);

			preg_match("/DESCRIPTION=\"(.*)\"\n/", $fconts, $res);
			$ret = $res[1];
		}
	}

	return($ret);
}

function get_app_vers ($appname) {

	$ret		= 0;
	$src_dir	= "/apps";

	if (!empty($appname)) {
		$file = $src_dir . "/" . $appname . "/VERSION";

		if ($fh = fopen($file, "r")) {

			$fconts = fread($fh, filesize($file));
			fclose($fh);

			preg_match("/VERSION=([0-9]*)/", $fconts, $res);
			$ret = $res[1];
		}
	}

	return($ret);
}

function print_form_settings ($root_db) {

	$div_l  = "<div style=\"margin-left: 5px;float: left; width: 200px; font-weight: bold;\">";
	$div_r  = "<div style=\"float: right; width: 125px;\">";

	$app_en = $root_db->get('root', 'userapp-enabled');

	$ret		= "<h2>UserApp Settings</h2>\n" .
			  "<form class=\"confForm\" name=\"app_form_settings\" action=\"index.php\"  method=\"POST\">\n" .
			  "\t" . $div_r . "\n" .
			  "\t\t<input type=\"hidden\" name=\"app_form_save\" value=\"1\" />\n" .
			  "\t\t<input type=\"submit\" value=\"Apply\" />\n" .
			  "\t</div>\n" .
			  "\t" . $div_l . "Enable support for UserApps:</div>\n" .
       			  "\t<div><input type=\"checkbox\" name=\"app_en\" value=\"1\"" . ($app_en == 1 ? " checked" : "") . " /></div>\n";

	 if ($app_en) {
		$app_user_en = $root_db->get('root', 'userapp-user-enabled');

		$ret	.= "\t<br />\n" .
			   "\t" . $div_l . "Enable SSH-Login:</div>\n" .
			   "\t<div><input type=\"checkbox\" name=\"app_user_en\" value=\"1\"" . ($app_user_en == 1 ? " checked" : "") . " /></div>\n";

		if ($app_user_en == 1) {
			$ret	.= "\t<br />\n" .
				   "\t" . $div_l . "Set password for SSH-Login:</div>\n" .
				   "\t<div style=\"margin-left: 230px;\"><input type=\"password\" name=\"app_user_pw_set\" /></div>\n" .
				   "\t<br />\n" .
			   	   "\t" . $div_l . "Reset password for SSH-Login:</div>\n" .
				   "\t<div><input type=\"checkbox\" name=\"app_user_pw_res\" value=\"1\" /></div>\n";
		}
	}

	$ret .= "</form>\n";

	return($ret);

}

function print_form_uins ($name) {

	$ret =	"<form class=\"confForm\" action=\"index.php\" name=\"app_uins\" method=\"POST\">\n" .
		"\t<input type=\"hidden\" name=\"app_name\" value=\"" . $name . "\" />\n" .
		"\t<input type=\"submit\" name=\"uninstall\" value=\"uninstall\" />\n" .
		"</form>\n";

	return($ret);
}

function print_form_ins () {

	$ret =	"<form class=\"confForm\" action=\"/app/berogui/index.php\" name=\"app_ins\" method=\"GET\">\n" .
		"\t<input type=\"hidden\" name=\"m\" value=\"up_tool\" />\n" .
		"\t<input type=\"submit\" value=\"install\" />\n" .
		"</form>\n";

	return($ret);
}

function get_apps_state ($root_db) {

	$ret =	"<h2>UserApp State</h2>\n";

	if ($root_db->get('root', 'userapp-enabled') == 1) {
		$ret .= 	"<form class=\"confForm\" action=\"index.php\" name=\"app_res\" method=\"POST\">\n" .
				"\t<div style=\"float: right; width: 125px;\">\n" .
				"\t\t<input type=\"hidden\" name=\"app_services_restart\" value=\"1\" />\n" .
				"\t\t<input type=\"submit\" value=\"restart\" />\n" .
				"\t</div>\n" .
				"</form>\n";
	}

	$ret .= "<div style=\"margin-left: 5px; font-weight: bold;\">UserApps are currently ";

	switch($root_db->get('root', 'userapp-status')) {
	case 'running':
		$ret .= "<span style=\"color: green;\">running</span>";
		break;
	case 'stopped':
		$ret .= "<span style=\"color: red;\">stopped</span>";
		break;
	case 'disabled':
		$ret .= "<span style=\"color: red;\">disabled</span>";
		break;
	}

	$ret .= ".</div>\n";

	return($ret);
}

function get_apps_links () {

	$apps = array();

	if ($dh = opendir('/apps')) {
		while (($file = readdir($dh)) !== false) {
			if ($file != ".." && $file != ".") {
				$tmp['name'] = $file;
				$tmp['url'] = '/userapp/' . $file;
				$apps[] = $tmp;
			}
		}

		closedir($dh);
	}

	return($apps);
}

function get_apps_installed () {

	$apps = array();

	if ($dh = opendir("/apps")) {
		while (($file = readdir($dh)) !== false) {
			if ($file != ".." && $file != ".") {
				$tmp['name'] = $file;
				$tmp['slot'] = get_app_slots($file);
				$tmp['desc'] = get_app_desc($file);
				$tmp['vers'] = get_app_vers($file);
				$apps[] = $tmp;
			}
		}

		closedir($dh);
	}

	$ret =	"<br /><br /><br />\n" .
		"<table class=\"contenttoc\" width=\"95%\">\n" .
		"\t<tr style=\"background-color: rgb(235,223,223);\">\n" .
		"\t\t<th colspan=\"5\">Installed Apps</th>\n" .
		"\t</tr>\n" .
		"\t<tr style=\"background-color: rgb(240,240,236);\">\n" .
		"\t\t<td width=\"4\"><b>Slot</b></td>" .
		"\t\t<td width=\"8\"><b>Name</b></td>" .
		"\t<td width=\"2\"><b>Version</b></td>" .
		"\t<td><b>Description</td>" .
		"\t<td width=\"8\"><b>Action</b></td>\n" .
		"\t</tr>\n";

	$i = 0;
	if (!empty($apps)) {
		foreach ($apps as $app) {

			$link = "<a href=\"" . $app['name'] . "\">" . $app['name'] . "</a>";
			$uins = print_form_uins($app['name']);

			$ret .= "\t<tr>\n" .
				"\t\t<td>" . ($i + 1) . "</td>\n" .
				"\t\t<td" . (($app['slot'] > 1) ? " rowspan=\"" . $app['slot'] . "\"" : "") . ">" . $link . "</td>\n" .
				"\t\t<td" . (($app['slot'] > 1) ? " rowspan=\"" . $app['slot'] . "\"" : "") . ">" . $app['vers'] . "</td>\n" .
				"\t\t<td" . (($app['slot'] > 1) ? " rowspan=\"" . $app['slot'] . "\"" : "") . ">" . $app['desc'] . "</td>\n" .
				"\t\t<td" . (($app['slot'] > 1) ? " rowspan=\"" . $app['slot'] . "\"" : "") . ">\n" . $uins . "\t</td>\n" .
				"\t</tr>\n";

			if ($app['slot'] > 1) {
				for ($j = 1; $j < $app['slot']; $j++) {
					$ret .= "\t<tr>\n" .
						"\t\t<td>" . ($i + $j + 1) . "</td>\n" .
						"\t</tr>\n";
				}

				$i += ($app['slot'] - 1);
			}
			$i++;
		}
	}

	if ($i < 8) {
		$ret .=	"\t<tr>\n" .
			"\t\t<td>" . ($i + 1) . "</td>\n" .
			"\t\t<td rowspan=\"" . (8 - $i) . "\">free</td>\n" .
			"\t\t<td rowspan=\"" . (8 - $i) . "\"></td>\n" .
			"\t\t<td rowspan=\"" . (8 - $i) . "\"></td>\n" .
			"\t\t<td rowspan=\"" . (8 - $i) . "\">\n" .
			print_form_ins() .
			"\t\t</td>\n" .
			"\t</tr>\n";

		for ($j = ($i + 1); $j < 8; $j++) {
				$ret .= "\t<tr>\n" .
					"\t\t<td>" . ($j + 1) . "</td>" .
					"\t</tr>\n";
		}
	}

	$ret .= "</table>\n";

	return($ret);
}

function print_app_mounts () {

	$ret =	"<br /><br /><br />\n" .
		"<table class=\"contenttoc\" width=\"95%\">\n" .
		"\t<tr style=\"background-color: rgb(235,223,223);\">\n" .
		"\t\t<th colspan=\"4\">Remote Shares</th>\n" .
		"\t</tr>\n" .
		"\t<tr style=\"background-color: rgb(240,240,236);\">\n" .
		"\t\t<td><b>Remote</b></td>\n" .
		"\t\t<td><b>Local</b></td>\n" .
		"\t\t<td><b>Type</b></td>\n" .
		"\t\t<td><b>Mounted</b></td>\n" .
		"\t</tr>\n";

	if (!($dh = opendir('/apps/'))) {
		return;
	}

	while ($sub = readdir($dh)) {

		if (($sub == '.') || ($sub == '..')) {
			continue;
		}

		if ($sub_fs = @file('/apps/' . $sub . '/etc/fstab')) {

			foreach ($sub_fs as $line) {

				if ($line[0] == '#') {
					continue;
				}

				$field = explode("\t", $line);

				exec('/bin/mount | grep ' . $field[0], $tmp, $mounted);

				$ret .=	"\t<tr>\n" .
					"\t\t<td>" . $field[0] . "</td>\n" .
					"\t\t<td>/apps/" . $sub . $field[1] . "</td>\n" .
					"\t\t<td>" . $field[2] . "</td>\n" .
					"\t\t<td>" . ($mounted == 0 ? "yes" : "no") . "</td>\n" .
					"\t</tr>\n";
			}
		}
	}

	closedir($dh);

	$ret .=	"</table>\n";

	return($ret);
}

function app_save_settings ($root_db, $conf) {

	$root_db->set('root', 'userapp-enabled', $conf['app_en']);
	$root_db->set('root', 'userapp-user-enabled', (($conf['app_en'] == 1) ? $conf['app_user_en'] : 0));

	if (isset($conf['app_user_pw_set'])) {
		exec('/usr/local/sbin/pwchange.sh admin ' . $conf['app_user_pw_set']);
	}

	if ($conf['app_user_pw_res']) {
		exec('/usr/local/sbin/reset_admin_passwd.sh');
	}

	exec('/etc/init.d/S91userapp update-user');

	switch($root_db->get('root', 'userapp-status')) {
	case 'running':
		if ($conf['app_en'] == 0) {
			exec('/etc/init.d/S91userapp stop');
		}
		break;
	case 'stopped':
		if ($conf['app_en'] == 1) {
			exec('/etc/init.d/S91userapp start');
		}
		break;
	}
}

$redir_login = "/app/berogui/includes/login.php";

# check if session is still active, if not go to login page
@session_start();
if (!isset($_SESSION['beroari_time'])) {
	header('Location:' . $redir_login);
	exit();
} elseif ((isset($_SESSION['beroari_time'])) && (($_SESSION['beroari_time'] + 1200) < time())) {
	session_unset();
	session_destroy();
	header('Location:' . $redir_login . '?reason=sess_expd');
	exit();
}

$_SESSION['beroari_time'] = time();

$root_db = new beroConf('root');

if (!$root_db->valid()) {
	$body	= "Invalid or damaged root.db!";
} else {

	if (isset($_POST['app_form_save'])) {
		app_save_settings($root_db, $_POST);
	}

	if (isset($_POST['uninstall'])) {
		exec('/usr/local/sbin/userapp_uninstall.sh ' . $_POST['app_name']);
	}

	if (isset($_POST['app_services_restart'])) {
		exec('/etc/init.d/S91userapp restart');
	}

	$body =	print_form_settings($root_db).
		get_apps_state($root_db);

	if (get_apps_enabled($root_db)) {
		$body .= get_apps_installed() .
			 print_app_mounts();
	}
}

echo	gui_header('UserApp Management', get_apps_links()) .
	$body .
	gui_footer();

?>
